/*
  Скетч к проекту "Бегущая строка"
*/

// ================ НАСТРОЙКИ ================
#define BRIGHTNESS 255     // стандартная яркость (0-255)      

#define CURRENT_LIMIT 0    // лимит по току в миллиамперах, автоматически управляет яркостью (пожалей свой блок питания!) 0 - выключить лимит

#define WIDTH 30              // ширина матрицы
#define HEIGHT 8              // высота матрицы
#define SEGMENTS 1            // диодов в одном "пикселе" (для создания матрицы из кусков ленты)

#define COLOR_ORDER GRB       // порядок цветов на ленте. Если цвет отображается некорректно - меняйте. Начать можно с RGB

#define MATRIX_TYPE 0         // тип матрицы: 0 - зигзаг, 1 - параллельная

// ============ ДЛЯ РАЗРАБОТЧИКОВ ============
// ПИНЫ
#define LED_PIN 4

// БИБЛИОТЕКИ
#include <FastLED.h>                  //работаем с адресной лентой
#include <WiFi.h>                     //работаем с WiFi
#include <WiFiClient.h>
#include <WiFiClientSecure.h>         //и с HTTPClient
#include <ArduinoJson.h>              //для парсинга JSON файлов
#include <HTTPClient.h>
#include "WiFiUdp.h"
#define COLOR_DEBTH 3                 // цветовая глубина: 1, 2, 3 (в байтах)
#include "fonts.h"


//==========НАСТРОЙКИ СОЕДИНЕНИЯ===========

const char* ssid = "root";                    // имя WiFi сети
const char* password = "rootroot";                // и пароль
byte wifi_connected = false;

int stringID = 1;                         //-----НОМЕР УСТРОЙСТВА. Меняется при создании копий
String IPaddress = "rstring.mgul.ac.ru";                    // основной домен, по которому будут проходить запросы. Например, из https://yandex.ru/pogoda/ домен будет yandex.ru
int Port = 40006;                         //Порт, на котором работает бэкенд

//=========ПРОЧИЕ НАСТРОЙКИ РАЗРАБОТЧИКА======

const int NUM_LEDS = WIDTH * HEIGHT * SEGMENTS;
CRGB leds[NUM_LEDS];
uint32_t scrollTimer;

boolean loadingFlag, fullTextFlag;
int regularparser = 0;


int colortype;                            // тип цвета. 0 - постоянный, 1 - мерцающая радуга, 2 - статичная радуга
int numberid = 0;
String text1;                             // сам выводимый текст
const char* txt1;                         // парсинг текста
String string_text;                       // массив текста
uint32_t string_color;                    // цвет текста
uint8_t string_speed = 60;                // скорость бегущего текста по умолчанию (мс)
uint8_t showed;                           // будет ли у нас отображаться определённый текст
int arraysize;                            // размер массива количества текстов на строку
int ids2[50];                             // массив айди



WiFiClient client;                        // создаём объект для работы с удалёнными хостами


void setup() {
  Serial.begin(9600);                     // последовательный порт на 9600 бод
  
WiFi.disconnect(true);
  wifi_connected = false;
  WiFi.mode(WIFI_AP_STA);


  // для дебага в мониторе порта
  if (strlen(ssid) > 0) {
 
    Serial.print(F("\nПодключение к "));  
    Serial.print(ssid);
  
  } 
  
    WiFi.begin(ssid, password);            // подключаемся к сети
  
    // Проверка соединения (таймаут 15 секунд)
    for (int j = 0; j < 15; j++ ) {
      wifi_connected = WiFi.status() == WL_CONNECTED;
      if (wifi_connected) {
        // Подключение установлено

        // для дебага в мониторе порта
        Serial.println();
        Serial.print(F("WiFi подключен. IP адрес: "));
        Serial.println(WiFi.localIP());

        break;
      }
      
  // для дебага в мониторе порта
      delay(1000);
      Serial.print(".");
  
    }
    Serial.println();      

    
      if (WiFi.status() == WL_CONNECTED){
        Serial.println(F("aboba"));
  getsize();
      }

      else {
Serial.println(F("Не удалось подключиться к сети WiFi."));
      // если не удалось подключиться - выводим информацию об этом на строку
    text1 = "Не удалось подключиться к сети " + String(ssid) + ". Проверьте правильность настройки подключения или точки доступа и перезагрузите устройство!";    
    string_color = 0xFF0000;
    string_speed = 50;
    loop();
    }
    
  // настройки ленты
 FastLED.addLeds<WS2812, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.setBrightness(BRIGHTNESS);
  FastLED.clear();
  FastLED.show();
 }

void getsize(){

if((WiFi.status() == WL_CONNECTED)) 
  {

      
    HTTPClient client;
    client.begin("http://" + String(IPaddress) + ":" + String(Port) + "/geet/string/" + String(stringID) + "/masize/");                        // подключаемся к сайту
    int httpCode = client.GET();                                      // получаем данные 
    if (httpCode > 0) {
      String getsizeid = client.getString();
      Serial.println("\nStatusCode: " + String(httpCode));            // выводим код подключения (200 - успешно, 3хх — перенаправление, 4xx — ошибка клиента, 5xx - ошибка сервера)
      Serial.println (getsizeid);                                        // выводим парсированные данные (для отладки в мониторе порта)
      char json0[50];
      getsizeid.toCharArray(json0, 50);
      Serial.println(json0);
      StaticJsonDocument <50> doc0;                                    // выделяем память json файла
      DeserializationError err = deserializeJson(doc0, json0); 

arraysize = doc0[0];

getsizeid.clear();                                 
doc0.clear();
memset(json0, 0, sizeof(json0));
client.end();
getinfo();
}
  }
}





//==========ПОЛУЧАЕМ==АЙДИ==ТЕКСТОВ=========
void getinfo() {
 
  if((WiFi.status() == WL_CONNECTED)) 
  {

      
    HTTPClient client;
    client.begin("http://" + String(IPaddress) + ":" + String(Port) + "/geet/string/" + String(stringID) + "/mas/");                        // подключаемся к сайту
    int httpCode = client.GET();                                      // получаем данные 
    if (httpCode > 0) {
      String getids = client.getString();
      Serial.println("\nStatusCode: " + String(httpCode));            // выводим код подключения (200 - успешно, 3хх — перенаправление, 4xx — ошибка клиента, 5xx - ошибка сервера)
      Serial.println (getids);                                        // выводим парсированные данные (для отладки в мониторе порта)
      char json[700];
      getids.toCharArray(json, 700);
      Serial.println(json);
      StaticJsonDocument <700> doc;                                    // выделяем память json файла
      DeserializationError err = deserializeJson(doc, json);          
        

for (int i = 0; i < arraysize; i++) {
  ids2[i] = {doc[i]};                                    // заполняем массив информацией об айди
}

//производим очистку
getids.clear();                                 
doc.clear();
memset(json, 0, sizeof(json));
client.end();
gettexts();

    }

  }

 }


 
//==========ПОЛУЧАЕМ==САМИ==ТЕКСТЫ=========
void gettexts(){


Serial.print(arraysize);
    HTTPClient client;
client.begin("http://" + String(IPaddress) + ":" + String(Port) + "/geet/tags/" + String(ids2[numberid]) + "/");
    int httpCode = client.GET();                                      // получаем данные 
    if (httpCode > 0) {
      String gettext = client.getString();
      Serial.println("\nStatusCode: " + String(httpCode));            // выводим код подключения (200 - успешно, 3хх — перенаправление, 4xx — ошибка клиента, 5xx - ошибка сервера
      Serial.println (gettext);                                       // выводим парсированные данные
      char json2[700];
      gettext.toCharArray(json2, 700);
      Serial.println(json2);
      StaticJsonDocument <700> doc2;                                    // выделяем память json файла
      DeserializationError err = deserializeJson(doc2, json2);          //

JsonObject root_0 = doc2[0];
const char* txtxt = root_0["stext"];                           // получаем текст
Serial.print(text1);                                               // для отладки в мониторе порта
int xspeed = root_0["string_speed"];                               // получаем скорость текста
string_color = root_0["string_color"];                               // получаем цвет текста
colortype = root_0["string_color_type"];                             // получаем тип цвета
string_speed = (0,1 * xspeed) + 40;

showed = root_0["showed"];                                           // будет ли отображаться текст
  if (showed == 1){
    text1 += String(txtxt);         //Работает!!!                  // если отображение = 1, то выводим текст
  }
  else {  
        text1 = "";                                                // если отображение = 0, то пропускаем текст
        string_speed = 1;
  }

  // завершаем работу парсера и делаем очистку
client.end();                                                           
doc2.clear();
gettext.clear();
memset(json2, 0, sizeof(json2));
loop();


}

  if (numberid > arraysize) {                 // если счётчик больше размера массива айди, то обнуляем его
  numberid = 0;
  client.end();                               // завершаем работу парсера
  text1.clear();
  delay(500);
  getsize();
}
    }

void loop() {
  //вызываем текст
string_text = text1;
fillString(string_text, string_color);
}
